"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useLocalState = void 0;
var immer_1 = __importDefault(require("immer"));
var react_1 = require("react");
function useLocalState(initialState) {
    function reducer(currentState, newState) {
        return newState;
    }
    var _a = react_1.useReducer(reducer, initialState), state = _a[0], setState = _a[1];
    function updateState(fn) {
        var newState = immer_1.default(state, fn);
        setState(newState);
    }
    return [state, setState, updateState];
}
exports.useLocalState = useLocalState;
